<template>
  <div class="order-row">
    <div class="order-row__top-row">
      <h4 class="order-row__title">Заказ #{{ order.id }}</h4>
      <span class="order-row__price">{{ order.total | rubCurrency }}</span>
    </div>

    <div class="order-row__bookings">
      <div class="table-wrapper">

        <table>
          <thead>
          <tr>
            <td>#</td>
            <td>Наименование</td>
            <td>Дополнительно</td>
            <td>Сумма</td>
          </tr>
          </thead>

          <tbody>
          <tr v-for="(booking, index) in order.cart"
              :key="index"
          >
            <td>{{ index + 1 }}</td>
            <td>{{ booking.name }}</td>
            <td>{{ booking.additional }}</td>
            <td>
              <p class="order-row__price-old"
                 v-if="booking.price_old !== undefined && booking.price_old !== null">
                {{ booking.price_old }} ₽
              </p>
              <p>{{ booking.price }} ₽</p>
            </td>
          </tr>
          </tbody>
        </table>

      </div>

    </div>

    <div class="order-row__comments" v-show="order.comments.length">
      <div class="order-row__comments-row"
           v-for="(comment, index) of order.comments"
           :key="index"
      >
        <span class="order-row__comments-author"
        >{{comment.author === 'customer' ? 'Я' : 'Арендодатель'}}
        </span>: <span class="order-row__comments-message"
        >{{comment.message}}</span>
      </div>
    </div>

    <div class="order-row__btns">

      <div class="order-row__statuses" v-if="order.paid || order.canceled">
        <template v-if="order.paid">
          <span class="order-row__paid">Оплачен</span>
        </template>

        <template v-if="order.canceled">
          <span class="order-row__canceled">Отменен</span>
        </template>
      </div>

      <template v-if="!order.canceled">
        <button class="order-row__btn button button--gray"
                v-if="order.can_cancel"
                @click="() => cancelOrder(order.id)">
          Отменить
        </button>

        <div class="order-row__pay" v-if="!order.paid">
          <base-select class="order-row__pay-type"
                       :options="selectOptions"
                       :value="payType"
                       label="Способ оплаты"
                       @onSelect="changePayType"
          />

          <button class="order-row__btn button button--green"
                  @click="() => payOrder(order.id)">
            Оплатить
          </button>
        </div>
      </template>
    </div>
  </div>
</template>

<script>
  import { mapActions } from 'vuex';

  import BaseSelect from './BaseSelect';

  import {
    cancelOrder as cancelOrderRequest,
    getPaymentLink
  } from '../service/deliroom-service';

  export default {
    name: 'OrderRow',
    components: {
      BaseSelect
    },
    props: {
      order: {
        type: Object,
        required: true
      },

      selectOptions: {
        type: Array,
        required: true,
      },
    },
    data: () => ({
      payType: null,
      comments: []
    }),

    methods: {
      ...mapActions({
        getAccountInfo: 'user/getAccountInfo'
      }),

      changePayType(event) {
        this.payType = event.value;
      },

      async cancelOrder(id) {
        const cancelResult = await cancelOrderRequest(id);
        await this.getAccountInfo();

        this.$emit('orderCanceled', { cancelResult, id });

      },

      async payOrder(id) {
        const payMethod = this.payType === 'card' || this.payType === null ? 1 : 2;

        const paymentLink = await getPaymentLink(id, { method: payMethod });

        if (paymentLink.message || paymentLink.data.errors) {

          this.$notify({
            group: 'errors',
            type: 'error',
            title: `Ошибка`,
            text: paymentLink.message || paymentLink.data.errors[0],
          });

        } else {
          if (paymentLink.data.payment_link) {
            window.location.href = paymentLink.data.payment_link;
          } else {
            this.$emit('needToUpdateOrders');
            await this.getAccountInfo();

            this.$router.push('/personal/orders');
          }
        }
      }
    }
  }
</script>

<style scoped lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .order-row {
    &__top-row {
      display: flex;
      align-items: center;
      justify-content: space-between;
    }

    &__title {
      @include h5;
    }

    &__price {
      @include p1;
    }

    &__price-old {
      @include p3;

      text-decoration: line-through;
    }

    &__btns {
      display: flex;
      align-items: center;
      justify-content: space-between;

      margin-top: rem(24);

      @media (max-width: $mobile-width) {
        flex-flow: column-reverse;
      }
    }

    &__btn {
      height: rem(50);

      @media (max-width: $mobile-width) {
        width: 100%;
      }
    }

    &__statuses {
      display: flex;

      span + span {
        margin-left: rem(16);
      }

      @media (max-width: $mobile-width) {
        align-self: flex-start;

        &:not(:last-child) {
          margin-top: rem(20);
        }
      }
    }

    &__canceled {
      @include p2;

      font-size: rem(16);
    }

    &__paid {
      @include p2;

      font-size: rem(16);
      color: $green;
    }

    &__bookings {
      margin: rem(16) 0 rem(32);

      .table-wrapper {
        @include table;

        td:first-child {
          width: rem(48);

          vertical-align: top;
        }

        td:last-child {
          width: rem(160);

          text-align: right;
          vertical-align: top;
        }
      }

    }

    &__pay {
      display: flex;
      align-items: center;

      @media (max-width: $mobile-width) {
        flex-flow: column;
        width: 100%;
        margin-bottom: rem(20);
      }
    }

    &__pay-type {
      width: rem(256);
      margin-right: rem(24);

      @media (max-width: $mobile-width) {
        width: 100%;
        margin-bottom: rem(12);
        margin-right: 0;
      }
    }

    &__comments-row {
      margin-bottom: rem(4);
    }

    &__comments-author {
      font-weight: bold;
      color: $green;
    }
  }
</style>
